<!DOCTYPE html>
<html>
  <head>
    <title>VueJS Course</title>
    <link rel="stylesheet" type="text/css" href="main.css" />
  </head>
  <body>
    <div id="app" v-cloak>
      <!-- {{ const foo = 5}} => Avoid using JS keyword as property name -->
      <!-- {{ firstName }} {{ lastName }} -->
      <!-- It's not ideal to write complex expressions inside the template. -->
      <p>{{ fullName }}</p>
      <!-- v-bind:href OR :href -->
      <p><a :href="url" target="_blank">Google</a></p>
      <!-- <p>{{ raw_url }}</p> -->
      <!-- will not work alone-->
      <p v-html="raw_url"></p>
      <p>{{ age }}</p>

      <hr />

      <label>First Name</label>
      <!-- lazy.trim will lesssen browser updates when inputting a certain data into the form -->
      <input type="text" v-model.lazy.trim="firstName" />

      <label>Middle Name</label>
      <!-- Keyboard Events and modifiers -->
      <input type="text" @keyup.enter="updateMiddleName" />

      <label>Last Name</label>
      <!-- <input type="text" :value="lastName" @input="updateLastName"/> -->
      <input
        type="text"
        :value="lastName"
        @input.prevent="updateLastName('Last name event triggered!', $event)"
      />

      <label>Age:</label>
      <input type="number" v-model.number="age" />

      <!-- Same with v-bind wherein we will use a ':' -->
      <!-- v-on:click => one can either execute code or pass in the name of the method you like to run whenever the event occurs -->
      <button type="button" v-on:click="increment">Increment</button>
      <button type="button" @click="age--">Decrement</button>
    </div>

    <!-- <div id="app2">
      {{ firstName }}
      {{ lastName }}
    </div> -->

    <!-- CDN -->
    <script src="https://unpkg.com/vue@3/dist/vue.global.js"></script>
    <script src="app.js"></script>
  </body>
</html>

<!-- NOTES -->
<!-- Expressions are the code  inside the curly brackets
  String interpolation is the process of replacing placeholders into string values
  "The expression {{ firstName }} is interpolated into John" -->
<!-- DIRECTIVES -->
<!-- To the browser, this is an attriute, but to view this is a directive. Unlike attriutes, directives change ow an element behaves. -->
<!-- All directives starts wth the V, then the name of the directive.  -->
<!-- REACTIVITY = is when an changes to the data is immediately reflected on the page -->
<!-- find the data propert and attach the V Modeldirective to the input field. -->
<!-- CROSS SITE SCRIPTING (XSS) -->
<!-- When malicious or harmful HTML is injected into the wepage causing unintended behavior in the browser -->
<!-- If you dont plan on passing anthing to our function, the parentheses can be omitted -->
<!-- EVENT MODIFIERS = they modify the way the event is handled -->
